## ffmpeg 4.3.9

=== libavformat/Makefile ===
NAME = avformat
DESC = FFmpeg container format library

HEADERS = avformat.h                                                    \
          avio.h                                                        \
          version.h                                                     \

OBJS = allformats.o         \
       avio.o               \
       aviobuf.o            \
       cutils.o             \
       dump.o               \
       format.o             \
       id3v1.o              \
       id3v2.o              \
       metadata.o           \
       mux.o                \
       options.o            \
       os_support.o         \
       qtpalette.o          \
       protocols.o          \
       riff.o               \
       sdp.o                \
       url.o                \
       utils.o              \

OBJS-$(HAVE_LIBC_MSVCRT)                 += file_open.o

# subsystems
OBJS-$(CONFIG_ISO_MEDIA)                 += isom.o
OBJS-$(CONFIG_NETWORK)                   += network.o
OBJS-$(CONFIG_RIFFDEC)                   += riffdec.o
OBJS-$(CONFIG_RIFFENC)                   += riffenc.o
OBJS-$(CONFIG_RTPDEC)                    += rdt.o                       \
                                            rtp.o                       \
                                            rtpdec.o                    \
                                            rtpdec_ac3.o                \
                                            rtpdec_amr.o                \
                                            rtpdec_asf.o                \
                                            rtpdec_dv.o                 \
                                            rtpdec_g726.o               \
                                            rtpdec_h261.o               \
                                            rtpdec_h263.o               \
                                            rtpdec_h263_rfc2190.o       \
                                            rtpdec_h264.o               \
                                            rtpdec_hevc.o               \
                                            rtpdec_ilbc.o               \
                                            rtpdec_jpeg.o               \
                                            rtpdec_latm.o               \
                                            rtpdec_mpa_robust.o         \
                                            rtpdec_mpeg12.o             \
                                            rtpdec_mpeg4.o              \
                                            rtpdec_mpegts.o             \
                                            rtpdec_qcelp.o              \
                                            rtpdec_qdm2.o               \
                                            rtpdec_qt.o                 \
                                            rtpdec_rfc4175.o            \
                                            rtpdec_svq3.o               \
                                            rtpdec_vc2hq.o              \
                                            rtpdec_vp8.o                \
                                            rtpdec_vp9.o                \
                                            rtpdec_xiph.o
OBJS-$(CONFIG_RTPENC_CHAIN)              += rtpenc_chain.o rtp.o
OBJS-$(CONFIG_SHARED)                    += log2_tab.o golomb_tab.o
OBJS-$(CONFIG_SRTP)                      += srtp.o

# muxers/demuxers
OBJS-$(CONFIG_A64_MUXER)                 += a64.o rawenc.o
OBJS-$(CONFIG_AA_DEMUXER)                += aadec.o
OBJS-$(CONFIG_AAC_DEMUXER)               += aacdec.o apetag.o img2.o rawdec.o
OBJS-$(CONFIG_AC3_DEMUXER)               += ac3dec.o rawdec.o
OBJS-$(CONFIG_AC3_MUXER)                 += rawenc.o
OBJS-$(CONFIG_ACM_DEMUXER)               += acm.o rawdec.o
OBJS-$(CONFIG_ACT_DEMUXER)               += act.o
OBJS-$(CONFIG_ADF_DEMUXER)               += bintext.o sauce.o
OBJS-$(CONFIG_ADP_DEMUXER)               += adp.o
OBJS-$(CONFIG_ADS_DEMUXER)               += ads.o
OBJS-$(CONFIG_ADTS_MUXER)                += adtsenc.o apetag.o img2.o \
                                            id3v2enc.o
OBJS-$(CONFIG_ADX_DEMUXER)               += adxdec.o
OBJS-$(CONFIG_ADX_MUXER)                 += rawenc.o
OBJS-$(CONFIG_AEA_DEMUXER)               += aea.o pcm.o
OBJS-$(CONFIG_AFC_DEMUXER)               += afc.o
OBJS-$(CONFIG_AIFF_DEMUXER)              += aiffdec.o pcm.o isom.o \
                                            mov_chan.o replaygain.o
OBJS-$(CONFIG_AIFF_MUXER)                += aiffenc.o id3v2enc.o
OBJS-$(CONFIG_AIX_DEMUXER)               += aixdec.o
OBJS-$(CONFIG_ALP_DEMUXER)               += alp.o
OBJS-$(CONFIG_AMR_DEMUXER)               += amr.o
OBJS-$(CONFIG_AMR_MUXER)                 += amr.o rawenc.o
OBJS-$(CONFIG_AMRNB_DEMUXER)             += amr.o
OBJS-$(CONFIG_AMRWB_DEMUXER)             += amr.o
OBJS-$(CONFIG_ANM_DEMUXER)               += anm.o
OBJS-$(CONFIG_APC_DEMUXER)               += apc.o
OBJS-$(CONFIG_APE_DEMUXER)               += ape.o apetag.o img2.o
OBJS-$(CONFIG_APM_DEMUXER)               += apm.o riffdec.o
OBJS-$(CONFIG_APNG_DEMUXER)              += apngdec.o
OBJS-$(CONFIG_APNG_MUXER)                += apngenc.o
OBJS-$(CONFIG_APTX_DEMUXER)              += aptxdec.o rawdec.o
OBJS-$(CONFIG_APTX_MUXER)                += rawenc.o
OBJS-$(CONFIG_APTX_HD_DEMUXER)           += aptxdec.o rawdec.o
OBJS-$(CONFIG_APTX_HD_MUXER)             += rawenc.o
OBJS-$(CONFIG_AQTITLE_DEMUXER)           += aqtitledec.o subtitles.o
OBJS-$(CONFIG_ARGO_ASF_DEMUXER)          += argo_asf.o
OBJS-$(CONFIG_ASF_DEMUXER)               += asfdec_f.o asf.o asfcrypt.o \
                                            avlanguage.o
OBJS-$(CONFIG_ASF_O_DEMUXER)             += asfdec_o.o asf.o asfcrypt.o \
                                            avlanguage.o
OBJS-$(CONFIG_ASF_MUXER)                 += asfenc.o asf.o avlanguage.o
OBJS-$(CONFIG_ASS_DEMUXER)               += assdec.o subtitles.o
OBJS-$(CONFIG_ASS_MUXER)                 += assenc.o
OBJS-$(CONFIG_AST_DEMUXER)               += ast.o astdec.o
OBJS-$(CONFIG_AST_MUXER)                 += ast.o astenc.o
OBJS-$(CONFIG_AU_DEMUXER)                += au.o pcm.o
OBJS-$(CONFIG_AU_MUXER)                  += au.o rawenc.o
OBJS-$(CONFIG_AVI_DEMUXER)               += avidec.o
OBJS-$(CONFIG_AVI_MUXER)                 += avienc.o mpegtsenc.o avlanguage.o rawutils.o
OBJS-$(CONFIG_AVM2_MUXER)                += swfenc.o swf.o
OBJS-$(CONFIG_AVR_DEMUXER)               += avr.o pcm.o
OBJS-$(CONFIG_AVS_DEMUXER)               += avs.o voc_packet.o vocdec.o voc.o
OBJS-$(CONFIG_AVS2_DEMUXER)              += davs2.o rawdec.o
OBJS-$(CONFIG_AVS2_MUXER)                += rawenc.o
OBJS-$(CONFIG_BETHSOFTVID_DEMUXER)       += bethsoftvid.o
OBJS-$(CONFIG_BFI_DEMUXER)               += bfi.o
OBJS-$(CONFIG_BINK_DEMUXER)              += bink.o
OBJS-$(CONFIG_BINTEXT_DEMUXER)           += bintext.o sauce.o
OBJS-$(CONFIG_BIT_DEMUXER)               += bit.o
OBJS-$(CONFIG_BIT_MUXER)                 += bit.o
OBJS-$(CONFIG_BMV_DEMUXER)               += bmv.o
OBJS-$(CONFIG_BOA_DEMUXER)               += boadec.o
OBJS-$(CONFIG_BFSTM_DEMUXER)             += brstm.o
OBJS-$(CONFIG_BRSTM_DEMUXER)             += brstm.o
OBJS-$(CONFIG_C93_DEMUXER)               += c93.o voc_packet.o vocdec.o voc.o
OBJS-$(CONFIG_CAF_DEMUXER)               += cafdec.o caf.o mov_chan.o mov_esds.o
OBJS-$(CONFIG_CAF_MUXER)                 += cafenc.o caf.o riff.o
OBJS-$(CONFIG_CAVSVIDEO_DEMUXER)         += cavsvideodec.o rawdec.o
OBJS-$(CONFIG_CAVSVIDEO_MUXER)           += rawenc.o
OBJS-$(CONFIG_CDG_DEMUXER)               += cdg.o
OBJS-$(CONFIG_CDXL_DEMUXER)              += cdxl.o
OBJS-$(CONFIG_CINE_DEMUXER)              += cinedec.o
OBJS-$(CONFIG_CODEC2_DEMUXER)            += codec2.o rawdec.o pcm.o
OBJS-$(CONFIG_CODEC2_MUXER)              += codec2.o rawenc.o
OBJS-$(CONFIG_CODEC2RAW_DEMUXER)         += codec2.o rawdec.o pcm.o
OBJS-$(CONFIG_CODEC2RAW_MUXER)           += rawenc.o
OBJS-$(CONFIG_CONCAT_DEMUXER)            += concatdec.o
OBJS-$(CONFIG_CRC_MUXER)                 += crcenc.o
OBJS-$(CONFIG_DATA_DEMUXER)              += rawdec.o
OBJS-$(CONFIG_DATA_MUXER)                += rawenc.o
OBJS-$(CONFIG_DASH_MUXER)                += dash.o dashenc.o hlsplaylist.o
OBJS-$(CONFIG_DASH_DEMUXER)              += dash.o dashdec.o
OBJS-$(CONFIG_DAUD_DEMUXER)              += dauddec.o
OBJS-$(CONFIG_DAUD_MUXER)                += daudenc.o
OBJS-$(CONFIG_DCSTR_DEMUXER)             += dcstr.o
OBJS-$(CONFIG_DERF_DEMUXER)              += derf.o pcm.o
OBJS-$(CONFIG_DFA_DEMUXER)               += dfa.o
OBJS-$(CONFIG_DHAV_DEMUXER)              += dhav.o
OBJS-$(CONFIG_DIRAC_DEMUXER)             += diracdec.o rawdec.o
OBJS-$(CONFIG_DIRAC_MUXER)               += rawenc.o
OBJS-$(CONFIG_DNXHD_DEMUXER)             += dnxhddec.o rawdec.o
OBJS-$(CONFIG_DNXHD_MUXER)               += rawenc.o
OBJS-$(CONFIG_DSF_DEMUXER)               += dsfdec.o
OBJS-$(CONFIG_DSICIN_DEMUXER)            += dsicin.o
OBJS-$(CONFIG_DSS_DEMUXER)               += dss.o
OBJS-$(CONFIG_DTSHD_DEMUXER)             += dtshddec.o
OBJS-$(CONFIG_DTS_DEMUXER)               += dtsdec.o rawdec.o
OBJS-$(CONFIG_DTS_MUXER)                 += rawenc.o
OBJS-$(CONFIG_DV_DEMUXER)                += dv.o
OBJS-$(CONFIG_DV_MUXER)                  += dvenc.o
OBJS-$(CONFIG_DVBSUB_DEMUXER)            += dvbsub.o rawdec.o
OBJS-$(CONFIG_DVBTXT_DEMUXER)            += dvbtxt.o rawdec.o
OBJS-$(CONFIG_DXA_DEMUXER)               += dxa.o
OBJS-$(CONFIG_EA_CDATA_DEMUXER)          += eacdata.o
OBJS-$(CONFIG_EA_DEMUXER)                += electronicarts.o
OBJS-$(CONFIG_EAC3_DEMUXER)              += ac3dec.o rawdec.o
OBJS-$(CONFIG_EAC3_MUXER)                += rawenc.o
OBJS-$(CONFIG_EPAF_DEMUXER)              += epafdec.o pcm.o
OBJS-$(CONFIG_FFMETADATA_DEMUXER)        += ffmetadec.o
OBJS-$(CONFIG_FFMETADATA_MUXER)          += ffmetaenc.o
OBJS-$(CONFIG_FIFO_MUXER)                += fifo.o
OBJS-$(CONFIG_FIFO_TEST_MUXER)           += fifo_test.o
OBJS-$(CONFIG_FILMSTRIP_DEMUXER)         += filmstripdec.o
OBJS-$(CONFIG_FILMSTRIP_MUXER)           += filmstripenc.o rawenc.o
OBJS-$(CONFIG_FITS_DEMUXER)              += fitsdec.o
OBJS-$(CONFIG_FITS_MUXER)                += fitsenc.o
OBJS-$(CONFIG_FLAC_DEMUXER)              += flacdec.o rawdec.o \
                                            flac_picture.o   \
                                            oggparsevorbis.o \
                                            replaygain.o     \
                                            vorbiscomment.o
OBJS-$(CONFIG_FLAC_MUXER)                += flacenc.o flacenc_header.o \
                                            vorbiscomment.o
OBJS-$(CONFIG_FLIC_DEMUXER)              += flic.o
OBJS-$(CONFIG_FLV_DEMUXER)               += flvdec.o
OBJS-$(CONFIG_LIVE_FLV_DEMUXER)          += flvdec.o
OBJS-$(CONFIG_FLV_MUXER)                 += flvenc.o avc.o
OBJS-$(CONFIG_FOURXM_DEMUXER)            += 4xm.o
OBJS-$(CONFIG_FRAMECRC_MUXER)            += framecrcenc.o framehash.o
OBJS-$(CONFIG_FRAMEHASH_MUXER)           += hashenc.o framehash.o
OBJS-$(CONFIG_FRAMEMD5_MUXER)            += hashenc.o framehash.o
OBJS-$(CONFIG_FRM_DEMUXER)               += frmdec.o
OBJS-$(CONFIG_FSB_DEMUXER)               += fsb.o
OBJS-$(CONFIG_FWSE_DEMUXER)              += fwse.o pcm.o
OBJS-$(CONFIG_GIF_MUXER)                 += gif.o
OBJS-$(CONFIG_GIF_DEMUXER)               += gifdec.o
OBJS-$(CONFIG_GSM_DEMUXER)               += gsmdec.o
OBJS-$(CONFIG_GSM_MUXER)                 += rawenc.o
OBJS-$(CONFIG_GXF_DEMUXER)               += gxf.o
OBJS-$(CONFIG_GXF_MUXER)                 += gxfenc.o
OBJS-$(CONFIG_G722_DEMUXER)              += g722.o rawdec.o
OBJS-$(CONFIG_G722_MUXER)                += rawenc.o
OBJS-$(CONFIG_G723_1_DEMUXER)            += g723_1.o
OBJS-$(CONFIG_G723_1_MUXER)              += rawenc.o
OBJS-$(CONFIG_G726_DEMUXER)              += g726.o
OBJS-$(CONFIG_G726_MUXER)                += rawenc.o
OBJS-$(CONFIG_G726LE_DEMUXER)            += g726.o

=== libavutil/Makefile ===
NAME = avutil
DESC = FFmpeg utility library

HEADERS = adler32.h                                                     \
          aes.h                                                         \
          aes_ctr.h                                                     \
          attributes.h                                                  \
          audio_fifo.h                                                  \
          avassert.h                                                    \
          avstring.h                                                    \
          avutil.h                                                      \
          base64.h                                                      \
          blowfish.h                                                    \
          bprint.h                                                      \
          bswap.h                                                       \
          buffer.h                                                      \
          cast5.h                                                       \
          camellia.h                                                    \
          channel_layout.h                                              \
          common.h                                                      \
          cpu.h                                                         \
          crc.h                                                         \
          des.h                                                         \
          dict.h                                                        \
          display.h                                                     \
          dovi_meta.h                                                   \
          downmix_info.h                                                \
          encryption_info.h                                             \
          error.h                                                       \
          eval.h                                                        \
          fifo.h                                                        \
          file.h                                                        \
          frame.h                                                       \
          hash.h                                                        \
          hdr_dynamic_metadata.h                                        \
          hmac.h                                                        \
          hwcontext.h                                                   \
          hwcontext_cuda.h                                              \
          hwcontext_d3d11va.h                                           \
          hwcontext_drm.h                                               \
          hwcontext_dxva2.h                                             \
          hwcontext_qsv.h                                               \
          hwcontext_mediacodec.h                                        \
          hwcontext_opencl.h                                            \
          hwcontext_vaapi.h                                             \
          hwcontext_videotoolbox.h                                      \
          hwcontext_vdpau.h                                             \
          hwcontext_vulkan.h                                            \
          imgutils.h                                                    \
          intfloat.h                                                    \
          intreadwrite.h                                                \
          lfg.h                                                         \
          log.h                                                         \
          macros.h                                                      \
          mathematics.h                                                 \
          mastering_display_metadata.h                                  \
          md5.h                                                         \
          mem.h                                                         \
          motion_vector.h                                               \
          murmur3.h                                                     \
          opt.h                                                         \
          parseutils.h                                                  \
          pixdesc.h                                                     \
          pixelutils.h                                                  \
          pixfmt.h                                                      \
          random_seed.h                                                 \
          rc4.h                                                         \
          rational.h                                                    \
          replaygain.h                                                  \
          ripemd.h                                                      \
          samplefmt.h                                                   \
          sha.h                                                         \
          sha512.h                                                      \
          spherical.h                                                   \
          stereo3d.h                                                    \
          threadmessage.h                                               \
          time.h                                                        \
          timecode.h                                                    \
          timestamp.h                                                   \
          tree.h                                                        \
          twofish.h                                                     \
          version.h                                                     \
          video_enc_params.h                                            \
          xtea.h                                                        \
          tea.h                                                         \
          tx.h                                                          \

HEADERS-$(CONFIG_LZO)                   += lzo.h

ARCH_HEADERS = bswap.h                                                  \
               intmath.h                                                \
               intreadwrite.h                                           \
               timer.h                                                  \

BUILT_HEADERS = avconfig.h                                              \
                ffversion.h

OBJS = adler32.o                                                        \
       aes.o                                                            \
       aes_ctr.o                                                        \
       audio_fifo.o                                                     \
       avstring.o                                                       \
       avsscanf.o                                                       \
       base64.o                                                         \
       blowfish.o                                                       \
       bprint.o                                                         \
       buffer.o                                                         \
       cast5.o                                                          \
       camellia.o                                                       \
       channel_layout.o                                                 \
       color_utils.o                                                    \
       cpu.o                                                            \
       crc.o                                                            \
       des.o                                                            \
       dict.o                                                           \
       display.o                                                        \
       dovi_meta.o                                                      \
       downmix_info.o                                                   \
       encryption_info.o                                                \
       error.o                                                          \
       eval.o                                                           \
       fifo.o                                                           \
       file.o                                                           \
       file_open.o                                                      \
       float_dsp.o                                                      \
       fixed_dsp.o                                                      \
       frame.o                                                          \
       hash.o                                                           \
       hdr_dynamic_metadata.o                                           \
       hmac.o                                                           \
       hwcontext.o                                                      \
       imgutils.o                                                       \
       integer.o                                                        \
       intmath.o                                                        \
       lfg.o                                                            \
       lls.o                                                            \
       log.o                                                            \
       log2_tab.o                                                       \
       mathematics.o                                                    \
       mastering_display_metadata.o                                     \
       md5.o                                                            \
       mem.o                                                            \
       murmur3.o                                                        \
       opt.o                                                            \
       parseutils.o                                                     \
       pixdesc.o                                                        \
       pixelutils.o                                                     \
       random_seed.o                                                    \
       rational.o                                                       \
       reverse.o                                                        \
       rc4.o                                                            \
       ripemd.o                                                         \
       samplefmt.o                                                      \
       sha.o                                                            \
       sha512.o                                                         \
       slicethread.o                                                    \
       spherical.o                                                      \
       stereo3d.o                                                       \
       threadmessage.o                                                  \
       time.o                                                           \
       timecode.o                                                       \
       tree.o                                                           \
       twofish.o                                                        \
       utils.o                                                          \
       xga_font_data.o                                                  \
       xtea.o                                                           \
       tea.o                                                            \
       tx.o                                                             \
       tx_float.o                                                       \

=== tools/Makefile ===
TOOLS = qt-faststart trasher uncoded_frame
TOOLS-$(CONFIG_LIBMYSOFA) += sofa2wavs
TOOLS-$(CONFIG_ZLIB) += cws2fws

tools/target_dec_%_fuzzer.o: tools/target_dec_fuzzer.c
	$(COMPILE_C) -DFFMPEG_DECODER=$*

tools/target_bsf_%_fuzzer.o: tools/target_bsf_fuzzer.c
	$(COMPILE_C) -DFFMPEG_BSF=$*

tools/target_dem_fuzzer.o: tools/target_dem_fuzzer.c
	$(COMPILE_C)

OUTDIRS += tools

clean::
	$(RM) $(CLEANSUFFIXES:%=tools/%)

-include $(wildcard tools/*.d)

=== libavcodec/aarch64/Makefile ===
# subsystems
OBJS-$(CONFIG_FFT)                      += aarch64/fft_init_aarch64.o
OBJS-$(CONFIG_FMTCONVERT)               += aarch64/fmtconvert_init.o
OBJS-$(CONFIG_H264CHROMA)               += aarch64/h264chroma_init_aarch64.o
OBJS-$(CONFIG_H264DSP)                  += aarch64/h264dsp_init_aarch64.o
OBJS-$(CONFIG_H264PRED)                 += aarch64/h264pred_init.o
OBJS-$(CONFIG_H264QPEL)                 += aarch64/h264qpel_init_aarch64.o
OBJS-$(CONFIG_HPELDSP)                  += aarch64/hpeldsp_init_aarch64.o
OBJS-$(CONFIG_IDCTDSP)                  += aarch64/idctdsp_init_aarch64.o
OBJS-$(CONFIG_MPEGAUDIODSP)             += aarch64/mpegaudiodsp_init.o
OBJS-$(CONFIG_NEON_CLOBBER_TEST)        += aarch64/neontest.o
OBJS-$(CONFIG_PIXBLOCKDSP)              += aarch64/pixblockdsp_init_aarch64.o
OBJS-$(CONFIG_VIDEODSP)                 += aarch64/videodsp_init.o
OBJS-$(CONFIG_VP8DSP)                   += aarch64/vp8dsp_init_aarch64.o

# decoders/encoders
OBJS-$(CONFIG_AAC_DECODER)              += aarch64/aacpsdsp_init_aarch64.o \
                                           aarch64/sbrdsp_init_aarch64.o
OBJS-$(CONFIG_DCA_DECODER)              += aarch64/synth_filter_init.o
OBJS-$(CONFIG_OPUS_DECODER)             += aarch64/opusdsp_init.o
OBJS-$(CONFIG_RV40_DECODER)             += aarch64/rv40dsp_init_aarch64.o
OBJS-$(CONFIG_VC1DSP)                   += aarch64/vc1dsp_init_aarch64.o
OBJS-$(CONFIG_VORBIS_DECODER)           += aarch64/vorbisdsp_init.o
OBJS-$(CONFIG_VP9_DECODER)              += aarch64/vp9dsp_init_10bpp_aarch64.o \
                                           aarch64/vp9dsp_init_12bpp_aarch64.o \
                                           aarch64/vp9mc_aarch64.o             \
                                           aarch64/vp9dsp_init_aarch64.o

# ARMv8 optimizations

# subsystems
ARMV8-OBJS-$(CONFIG_VIDEODSP)           += aarch64/videodsp.o

# NEON optimizations

# subsystems
NEON-OBJS-$(CONFIG_AAC_DECODER)         += aarch64/sbrdsp_neon.o
NEON-OBJS-$(CONFIG_FFT)                 += aarch64/fft_neon.o
NEON-OBJS-$(CONFIG_FMTCONVERT)          += aarch64/fmtconvert_neon.o
NEON-OBJS-$(CONFIG_H264CHROMA)          += aarch64/h264cmc_neon.o
NEON-OBJS-$(CONFIG_H264DSP)             += aarch64/h264dsp_neon.o              \
                                           aarch64/h264idct_neon.o
NEON-OBJS-$(CONFIG_H264PRED)            += aarch64/h264pred_neon.o
NEON-OBJS-$(CONFIG_H264QPEL)            += aarch64/h264qpel_neon.o             \
                                           aarch64/hpeldsp_neon.o
NEON-OBJS-$(CONFIG_HPELDSP)             += aarch64/hpeldsp_neon.o
NEON-OBJS-$(CONFIG_IDCTDSP)             += aarch64/simple_idct_neon.o
NEON-OBJS-$(CONFIG_MDCT)                += aarch64/mdct_neon.o
NEON-OBJS-$(CONFIG_MPEGAUDIODSP)        += aarch64/mpegaudiodsp_neon.o
NEON-OBJS-$(CONFIG_PIXBLOCKDSP)         += aarch64/pixblockdsp_neon.o
NEON-OBJS-$(CONFIG_VP8DSP)              += aarch64/vp8dsp_neon.o

# decoders/encoders
NEON-OBJS-$(CONFIG_AAC_DECODER)         += aarch64/aacpsdsp_neon.o
NEON-OBJS-$(CONFIG_DCA_DECODER)         += aarch64/synth_filter_neon.o
NEON-OBJS-$(CONFIG_OPUS_DECODER)        += aarch64/opusdsp_neon.o
NEON-OBJS-$(CONFIG_VORBIS_DECODER)      += aarch64/vorbisdsp_neon.o
NEON-OBJS-$(CONFIG_VP9_DECODER)         += aarch64/vp9itxfm_16bpp_neon.o       \
                                           aarch64/vp9itxfm_neon.o             \
                                           aarch64/vp9lpf_16bpp_neon.o         \
                                           aarch64/vp9lpf_neon.o               \
                                           aarch64/vp9mc_16bpp_neon.o          \
                                           aarch64/vp9mc_neon.o

=== libavcodec/arm/Makefile ===
ARCH_HEADERS = mathops.h

# subsystems
OBJS-$(CONFIG_AC3DSP)                  += arm/ac3dsp_init_arm.o         \
                                          arm/ac3dsp_arm.o
OBJS-$(CONFIG_AUDIODSP)                += arm/audiodsp_init_arm.o
OBJS-$(CONFIG_BLOCKDSP)                += arm/blockdsp_init_arm.o
OBJS-$(CONFIG_FFT)                     += arm/fft_init_arm.o            \
                                          arm/fft_fixed_init_arm.o
OBJS-$(CONFIG_FLACDSP)                 += arm/flacdsp_init_arm.o        \
                                          arm/flacdsp_arm.o
OBJS-$(CONFIG_FMTCONVERT)              += arm/fmtconvert_init_arm.o
OBJS-$(CONFIG_G722DSP)                 += arm/g722dsp_init_arm.o
OBJS-$(CONFIG_H264CHROMA)              += arm/h264chroma_init_arm.o
OBJS-$(CONFIG_H264DSP)                 += arm/h264dsp_init_arm.o
OBJS-$(CONFIG_H264PRED)                += arm/h264pred_init_arm.o
OBJS-$(CONFIG_H264QPEL)                += arm/h264qpel_init_arm.o
OBJS-$(CONFIG_HPELDSP)                 += arm/hpeldsp_init_arm.o        \
                                          arm/hpeldsp_arm.o
OBJS-$(CONFIG_IDCTDSP)                 += arm/idctdsp_init_arm.o        \
                                          arm/idctdsp_arm.o             \
                                          arm/jrevdct_arm.o             \
                                          arm/simple_idct_arm.o
OBJS-$(CONFIG_LLAUDDSP)                += arm/lossless_audiodsp_init_arm.o
OBJS-$(CONFIG_ME_CMP)                  += arm/me_cmp_init_arm.o
OBJS-$(CONFIG_MPEGAUDIODSP)            += arm/mpegaudiodsp_init_arm.o
OBJS-$(CONFIG_MPEGVIDEO)               += arm/mpegvideo_arm.o
OBJS-$(CONFIG_MPEGVIDEOENC)            += arm/mpegvideoencdsp_init_arm.o
OBJS-$(CONFIG_NEON_CLOBBER_TEST)       += arm/neontest.o
OBJS-$(CONFIG_PIXBLOCKDSP)             += arm/pixblockdsp_init_arm.o
OBJS-$(CONFIG_RDFT)                    += arm/rdft_init_arm.o
OBJS-$(CONFIG_RV34DSP)                 += arm/rv34dsp_init_arm.o
OBJS-$(CONFIG_VC1DSP)                  += arm/vc1dsp_init_arm.o
OBJS-$(CONFIG_VIDEODSP)                += arm/videodsp_init_arm.o
OBJS-$(CONFIG_VP3DSP)                  += arm/vp3dsp_init_arm.o
OBJS-$(CONFIG_VP8DSP)                  += arm/vp8dsp_init_arm.o

# decoders/encoders
OBJS-$(CONFIG_AAC_DECODER)             += arm/aacpsdsp_init_arm.o       \
                                          arm/sbrdsp_init_arm.o
OBJS-$(CONFIG_DCA_DECODER)             += arm/synth_filter_init_arm.o
OBJS-$(CONFIG_HEVC_DECODER)            += arm/hevcdsp_init_arm.o
OBJS-$(CONFIG_MLP_DECODER)             += arm/mlpdsp_init_arm.o
OBJS-$(CONFIG_RV40_DECODER)            += arm/rv40dsp_init_arm.o
OBJS-$(CONFIG_SBC_ENCODER)             += arm/sbcdsp_init_arm.o
OBJS-$(CONFIG_TRUEHD_DECODER)          += arm/mlpdsp_init_arm.o
OBJS-$(CONFIG_VORBIS_DECODER)          += arm/vorbisdsp_init_arm.o
OBJS-$(CONFIG_VP6_DECODER)             += arm/vp6dsp_init_arm.o
OBJS-$(CONFIG_VP9_DECODER)             += arm/vp9dsp_init_10bpp_arm.o   \
                                          arm/vp9dsp_init_12bpp_arm.o   \
                                          arm/vp9dsp_init_arm.o


# ARMv5 optimizations
# subsystems
ARMV5TE-OBJS-$(CONFIG_IDCTDSP)         += arm/idctdsp_init_armv5te.o    \
                                          arm/simple_idct_armv5te.o
ARMV5TE-OBJS-$(CONFIG_MPEGVIDEO)       += arm/mpegvideo_armv5te.o       \
                                          arm/mpegvideo_armv5te_s.o
ARMV5TE-OBJS-$(CONFIG_VIDEODSP)        += arm/videodsp_init_armv5te.o   \
                                          arm/videodsp_armv5te.o

# decoders/encoders
ARMV5TE-OBJS-$(CONFIG_MLP_DECODER)     += arm/mlpdsp_armv5te.o
ARMV5TE-OBJS-$(CONFIG_TRUEHD_DECODER)  += arm/mlpdsp_armv5te.o


# ARMv6 optimizations
# subsystems
ARMV6-OBJS-$(CONFIG_AC3DSP)            += arm/ac3dsp_armv6.o
ARMV6-OBJS-$(CONFIG_HPELDSP)           += arm/hpeldsp_init_armv6.o      \
                                          arm/hpeldsp_armv6.o
ARMV6-OBJS-$(CONFIG_IDCTDSP)           += arm/idctdsp_init_armv6.o      \
                                          arm/idctdsp_armv6.o           \
                                          arm/simple_idct_armv6.o
ARMV6-OBJS-$(CONFIG_ME_CMP)            += arm/me_cmp_armv6.o
ARMV6-OBJS-$(CONFIG_MPEGAUDIODSP)      += arm/mpegaudiodsp_fixed_armv6.o
ARMV6-OBJS-$(CONFIG_MPEGVIDEOENC)      += arm/mpegvideoencdsp_armv6.o
ARMV6-OBJS-$(CONFIG_PIXBLOCKDSP)       += arm/pixblockdsp_armv6.o
ARMV6-OBJS-$(CONFIG_STARTCODE)         += arm/startcode_armv6.o
ARMV6-OBJS-$(CONFIG_VP8DSP)            += arm/vp8_armv6.o               \
                                          arm/vp8dsp_init_armv6.o       \
                                          arm/vp8dsp_armv6.o

# decoders/encoders
ARMV6-OBJS-$(CONFIG_MLP_DECODER)       += arm/mlpdsp_armv6.o
ARMV6-OBJS-$(CONFIG_SBC_ENCODER)       += arm/sbcdsp_armv6.o
ARMV6-OBJS-$(CONFIG_TRUEHD_DECODER)    += arm/mlpdsp_armv6.o


# VFP optimizations

# subsystems
VFP-OBJS-$(CONFIG_FFT)                 += arm/fft_vfp.o
VFP-OBJS-$(CONFIG_FMTCONVERT)          += arm/fmtconvert_vfp.o
VFP-OBJS-$(CONFIG_MDCT)                += arm/mdct_vfp.o

# decoders/encoders
VFP-OBJS-$(CONFIG_DCA_DECODER)         += arm/synth_filter_vfp.o


# NEON optimizations

# subsystems
NEON-OBJS-$(CONFIG_AC3DSP)             += arm/ac3dsp_neon.o
NEON-OBJS-$(CONFIG_AUDIODSP)           += arm/audiodsp_init_neon.o      \
                                          arm/audiodsp_neon.o           \
                                          arm/int_neon.o
NEON-OBJS-$(CONFIG_BLOCKDSP)           += arm/blockdsp_init_neon.o      \
                                          arm/blockdsp_neon.o
NEON-OBJS-$(CONFIG_FFT)                += arm/fft_neon.o                \
                                          arm/fft_fixed_neon.o
NEON-OBJS-$(CONFIG_FMTCONVERT)         += arm/fmtconvert_neon.o
NEON-OBJS-$(CONFIG_G722DSP)            += arm/g722dsp_neon.o
NEON-OBJS-$(CONFIG_H264CHROMA)         += arm/h264cmc_neon.o
NEON-OBJS-$(CONFIG_H264DSP)            += arm/h264dsp_neon.o            \
                                          arm/h264idct_neon.o
NEON-OBJS-$(CONFIG_H264PRED)           += arm/h264pred_neon.o
NEON-OBJS-$(CONFIG_H264QPEL)           += arm/h264qpel_neon.o           \
                                          arm/hpeldsp_neon.o
NEON-OBJS-$(CONFIG_HPELDSP)            += arm/hpeldsp_init_neon.o       \
                                          arm/hpeldsp_neon.o
NEON-OBJS-$(CONFIG_IDCTDSP)            += arm/idctdsp_init_neon.o       \
                                          arm/idctdsp_neon.o            \
                                          arm/simple_idct_neon.o
NEON-OBJS-$(CONFIG_MDCT)               += arm/mdct_neon.o               \
                                          arm/mdct_fixed_neon.o
NEON-OBJS-$(CONFIG_MPEGVIDEO)          += arm/mpegvideo_neon.o
NEON-OBJS-$(CONFIG_PIXBLOCKDSP)        += arm/pixblockdsp_neon.o
NEON-OBJS-$(CONFIG_RDFT)               += arm/rdft_neon.o
NEON-OBJS-$(CONFIG_VC1DSP)             += arm/vc1dsp_init_neon.o        \
                                          arm/vc1dsp_neon.o
NEON-OBJS-$(CONFIG_VP3DSP)             += arm/vp3dsp_neon.o
NEON-OBJS-$(CONFIG_VP8DSP)             += arm/vp8dsp_init_neon.o        \
                                          arm/vp8dsp_neon.o

# decoders/encoders
NEON-OBJS-$(CONFIG_AAC_DECODER)        += arm/aacpsdsp_neon.o           \
                                          arm/sbrdsp_neon.o
NEON-OBJS-$(CONFIG_LLAUDDSP)           += arm/lossless_audiodsp_neon.o
NEON-OBJS-$(CONFIG_DCA_DECODER)        += arm/synth_filter_neon.o
NEON-OBJS-$(CONFIG_HEVC_DECODER)       += arm/hevcdsp_init_neon.o       \
                                          arm/hevcdsp_deblock_neon.o    \
                                          arm/hevcdsp_idct_neon.o       \
                                          arm/hevcdsp_qpel_neon.o       \
                                          arm/hevcdsp_sao_neon.o
NEON-OBJS-$(CONFIG_RV30_DECODER)       += arm/rv34dsp_neon.o
NEON-OBJS-$(CONFIG_RV40_DECODER)       += arm/rv34dsp_neon.o            \
                                          arm/rv40dsp_neon.o
NEON-OBJS-$(CONFIG_SBC_ENCODER)        += arm/sbcdsp_neon.o
NEON-OBJS-$(CONFIG_VORBIS_DECODER)     += arm/vorbisdsp_neon.o
NEON-OBJS-$(CONFIG_VP6_DECODER)        += arm/vp6dsp_neon.o
NEON-OBJS-$(CONFIG_VP9_DECODER)        += arm/vp9itxfm_16bpp_neon.o     \
                                          arm/vp9itxfm_neon.o           \
                                          arm/vp9lpf_16bpp_neon.o       \
                                          arm/vp9lpf_neon.o             \
                                          arm/vp9mc_16bpp_neon.o        \
                                          arm/vp9mc_neon.o

=== libavcodec/mips/Makefile ===
MIPSFPU-OBJS-$(CONFIG_AMRNB_DECODER)      += mips/acelp_filters_mips.o     \
                                             mips/celp_filters_mips.o      \
                                             mips/celp_math_mips.o         \
                                             mips/acelp_vectors_mips.o
MIPSFPU-OBJS-$(CONFIG_AMRWB_DECODER)      += mips/acelp_filters_mips.o     \
                                             mips/celp_filters_mips.o      \
                                             mips/amrwbdec_mips.o          \
                                             mips/celp_math_mips.o         \
                                             mips/acelp_vectors_mips.o
MIPSFPU-OBJS-$(CONFIG_MPEGAUDIODSP)       += mips/mpegaudiodsp_mips_float.o
MIPSDSP-OBJS-$(CONFIG_MPEGAUDIODSP)       += mips/mpegaudiodsp_mips_fixed.o
MIPSFPU-OBJS-$(CONFIG_FFT)                += mips/fft_mips.o
MIPSFPU-OBJS-$(CONFIG_FMTCONVERT)         += mips/fmtconvert_mips.o
OBJS-$(CONFIG_AC3DSP)                     += mips/ac3dsp_mips.o
OBJS-$(CONFIG_AAC_DECODER)                += mips/aacdec_mips.o            \
                                             mips/aacsbr_mips.o            \
                                             mips/sbrdsp_mips.o            \
                                             mips/aacpsdsp_mips.o
MIPSDSP-OBJS-$(CONFIG_AAC_ENCODER)        += mips/aaccoder_mips.o
MIPSFPU-OBJS-$(CONFIG_AAC_ENCODER)        += mips/iirfilter_mips.o
OBJS-$(CONFIG_HEVC_DECODER)               += mips/hevcdsp_init_mips.o      \
                                             mips/hevcpred_init_mips.o
OBJS-$(CONFIG_VP9_DECODER)                += mips/vp9dsp_init_mips.o
OBJS-$(CONFIG_VP8_DECODER)                += mips/vp8dsp_init_mips.o
OBJS-$(CONFIG_VP3DSP)                     += mips/vp3dsp_init_mips.o
OBJS-$(CONFIG_H264DSP)                    += mips/h264dsp_init_mips.o
OBJS-$(CONFIG_H264QPEL)                   += mips/h264qpel_init_mips.o
OBJS-$(CONFIG_H264CHROMA)                 += mips/h264chroma_init_mips.o
OBJS-$(CONFIG_H264PRED)                   += mips/h264pred_init_mips.o
OBJS-$(CONFIG_H263DSP)                    += mips/h263dsp_init_mips.o
OBJS-$(CONFIG_QPELDSP)                    += mips/qpeldsp_init_mips.o
OBJS-$(CONFIG_HPELDSP)                    += mips/hpeldsp_init_mips.o
OBJS-$(CONFIG_BLOCKDSP)                   += mips/blockdsp_init_mips.o
OBJS-$(CONFIG_PIXBLOCKDSP)                += mips/pixblockdsp_init_mips.o
OBJS-$(CONFIG_IDCTDSP)                    += mips/idctdsp_init_mips.o
OBJS-$(CONFIG_MPEGVIDEO)                  += mips/mpegvideo_init_mips.o
OBJS-$(CONFIG_MPEGVIDEOENC)               += mips/mpegvideoencdsp_init_mips.o
OBJS-$(CONFIG_ME_CMP)                     += mips/me_cmp_init_mips.o
OBJS-$(CONFIG_MPEG4_DECODER)              += mips/xvididct_init_mips.o
OBJS-$(CONFIG_VC1DSP)                     += mips/vc1dsp_init_mips.o
OBJS-$(CONFIG_WMV2DSP)                    += mips/wmv2dsp_init_mips.o
OBJS-$(CONFIG_VIDEODSP)                   += mips/videodsp_init.o
MSA-OBJS-$(CONFIG_HEVC_DECODER)           += mips/hevcdsp_msa.o            \
                                             mips/hevc_mc_uni_msa.o        \
                                             mips/hevc_mc_uniw_msa.o       \
                                             mips/hevc_mc_bi_msa.o         \
                                             mips/hevc_mc_biw_msa.o        \
                                             mips/hevc_idct_msa.o          \
                                             mips/hevc_lpf_sao_msa.o       \
                                             mips/hevcpred_msa.o
MSA-OBJS-$(CONFIG_VP9_DECODER)            += mips/vp9_mc_msa.o             \
                                             mips/vp9_lpf_msa.o            \
                                             mips/vp9_idct_msa.o           \
                                             mips/vp9_intra_msa.o
MSA-OBJS-$(CONFIG_VP8_DECODER)            += mips/vp8_mc_msa.o             \
                                             mips/vp8_idct_msa.o           \
                                             mips/vp8_lpf_msa.o
MSA-OBJS-$(CONFIG_VP3DSP)                 += mips/vp3dsp_idct_msa.o
MSA-OBJS-$(CONFIG_H264DSP)                += mips/h264dsp_msa.o            \
                                             mips/h264idct_msa.o
MSA-OBJS-$(CONFIG_H264QPEL)               += mips/h264qpel_msa.o
MSA-OBJS-$(CONFIG_H264CHROMA)             += mips/h264chroma_msa.o
MSA-OBJS-$(CONFIG_H264PRED)               += mips/h264pred_msa.o
MSA-OBJS-$(CONFIG_H263DSP)                += mips/h263dsp_msa.o
MSA-OBJS-$(CONFIG_QPELDSP)                += mips/qpeldsp_msa.o
MSA-OBJS-$(CONFIG_HPELDSP)                += mips/hpeldsp_msa.o
MSA-OBJS-$(CONFIG_BLOCKDSP)               += mips/blockdsp_msa.o
MSA-OBJS-$(CONFIG_PIXBLOCKDSP)            += mips/pixblockdsp_msa.o
MSA-OBJS-$(CONFIG_IDCTDSP)                += mips/idctdsp_msa.o           \
                                             mips/simple_idct_msa.o
MSA-OBJS-$(CONFIG_MPEGVIDEO)              += mips/mpegvideo_msa.o
MSA-OBJS-$(CONFIG_MPEGVIDEOENC)           += mips/mpegvideoencdsp_msa.o
MSA-OBJS-$(CONFIG_ME_CMP)                 += mips/me_cmp_msa.o
MMI-OBJS                                  += mips/constants.o
MMI-OBJS-$(CONFIG_H264DSP)                += mips/h264dsp_mmi.o
MMI-OBJS-$(CONFIG_H264CHROMA)             += mips/h264chroma_mmi.o
MMI-OBJS-$(CONFIG_H264PRED)               += mips/h264pred_mmi.o
MMI-OBJS-$(CONFIG_MPEGVIDEO)              += mips/mpegvideo_mmi.o
MMI-OBJS-$(CONFIG_IDCTDSP)                += mips/idctdsp_mmi.o           \
                                             mips/simple_idct_mmi.o
MMI-OBJS-$(CONFIG_MPEG4_DECODER)          += mips/xvid_idct_mmi.o
MMI-OBJS-$(CONFIG_BLOCKDSP)               += mips/blockdsp_mmi.o
MMI-OBJS-$(CONFIG_PIXBLOCKDSP)            += mips/pixblockdsp_mmi.o
MMI-OBJS-$(CONFIG_H264QPEL)               += mips/h264qpel_mmi.o
MMI-OBJS-$(CONFIG_VP8_DECODER)            += mips/vp8dsp_mmi.o
MMI-OBJS-$(CONFIG_HPELDSP)                += mips/hpeldsp_mmi.o
MMI-OBJS-$(CONFIG_VC1_DECODER)            += mips/vc1dsp_mmi.o
MMI-OBJS-$(CONFIG_WMV2DSP)                += mips/wmv2dsp_mmi.o
MMI-OBJS-$(CONFIG_HEVC_DECODER)           += mips/hevcdsp_mmi.o
MMI-OBJS-$(CONFIG_VP3DSP)                 += mips/vp3dsp_idct_mmi.o
MMI-OBJS-$(CONFIG_VP9_DECODER)            += mips/vp9_mc_mmi.o
MSA-OBJS-$(CONFIG_VC1_DECODER)            += mips/vc1dsp_msa.o

=== libavfilter/dnn/Makefile ===
OBJS-$(CONFIG_DNN)                           += dnn/dnn_interface.o
OBJS-$(CONFIG_DNN)                           += dnn/dnn_backend_native.o
OBJS-$(CONFIG_DNN)                           += dnn/dnn_backend_native_layers.o
OBJS-$(CONFIG_DNN)                           += dnn/dnn_backend_native_layer_pad.o
OBJS-$(CONFIG_DNN)                           += dnn/dnn_backend_native_layer_conv2d.o
OBJS-$(CONFIG_DNN)                           += dnn/dnn_backend_native_layer_depth2space.o
OBJS-$(CONFIG_DNN)                           += dnn/dnn_backend_native_layer_maximum.o
OBJS-$(CONFIG_DNN)                           += dnn/dnn_backend_native_layer_mathbinary.o
OBJS-$(CONFIG_DNN)                           += dnn/dnn_backend_native_layer_mathunary.o

DNN-OBJS-$(CONFIG_LIBTENSORFLOW)             += dnn/dnn_backend_tf.o

OBJS-$(CONFIG_DNN)                           += $(DNN-OBJS-yes)

=== libavutil/x86/Makefile ===
OBJS += x86/cpu.o                                                       \
        x86/fixed_dsp_init.o                                            \
        x86/float_dsp_init.o                                            \
        x86/imgutils_init.o                                             \
        x86/lls_init.o                                                  \

OBJS-$(CONFIG_PIXELUTILS) += x86/pixelutils_init.o                      \

EMMS_OBJS_$(HAVE_MMX_INLINE)_$(HAVE_MMX_EXTERNAL)_$(HAVE_MM_EMPTY) = x86/emms.o

X86ASM-OBJS += x86/cpuid.o                                              \
             $(EMMS_OBJS__yes_)                                      \
             x86/fixed_dsp.o                                            \
             x86/float_dsp.o                                            \
             x86/imgutils.o                                             \
             x86/lls.o                                                  \

X86ASM-OBJS-$(CONFIG_PIXELUTILS) += x86/pixelutils.o                    \

=== debian/changelog ===
ffmpeg (8:4.3.9-0+deb11u1+rpt1) bullseye; urgency=medium

  * HW accel patch 24
  * Bump epoch to take priority over Debian and Raspbian builds

 -- Serge Schneider <serge@raspberrypi.com>  Tue, 05 Aug 2025 11:38:08 +0100

ffmpeg (7:4.3.9-0+deb11u1) bullseye-security; urgency=medium

  * Non-maintainer upload by the LTS Team.
  * New upstream release.
    - CVE-2023-6601: Triggering arbitrary demuxers via base64 data URIs
    - CVE-2023-6602: Improper parsing of input files in HLS playlists
    - CVE-2023-6604: Demuxing of arbitrary data as XBIN-formatted data
    - CVE-2023-6605: Arbitrary HTTP GET requests via crafted DASH playlist

 -- Adrian Bunk <bunk@debian.org>  Mon, 14 Jul 2025 11:08:05 +0300

=== debian/control ===
Source: ffmpeg
Section: video
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders: Andreas Cadhalpun <Andreas.Cadhalpun@googlemail.com>,
 Alexander Strasser <eclipse7@gmx.net>,
 Reinhard Tartler <siretart@tauware.de>,
 Balint Reczey <balint@balintreczey.hu>,
 James Cowgill <jcowgill@debian.org>,
Rules-Requires-Root: no
Homepage: https://ffmpeg.org/
Standards-Version: 4.5.1
Vcs-Git: https://salsa.debian.org/multimedia-team/ffmpeg.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/ffmpeg
Build-Depends-Indep:
# needed to minify the CSS files
 cleancss,
# Autogenerated documentation
 doxygen,
# needed to create the CSS files for the HTML manuals
 node-less,
# generates top level manual page listing
 tree,
Build-Depends:
# needed for dh
 debhelper-compat (= 13),
# --enable-libflite
 flite1-dev,
# --enable-frei0r
 frei0r-plugins-dev <!pkg.ffmpeg.stage1>,
# --enable-ladspa
 ladspa-sdk,
# --enable-libaom
 libaom-dev,
# --enable-libaribb24
 libaribb24-dev,
# --enable-libass
 libass-dev,
# --enable-libbluray
 libbluray-dev,
# --enable-libbs2b
 libbs2b-dev,
# autodetected: external library 'bzlib'
 libbz2-dev,
# --enable-libcaca
 libcaca-dev,
# --enable-libcdio
 libcdio-paranoia-dev,
# --enable-libchromaprint
 libchromaprint-dev <!pkg.ffmpeg.stage1>,
# --enable-libcodec2
 libcodec2-dev,
# --enable-libdav1d
 libdav1d-dev,
# --enable-libdc1394
 libdc1394-dev [linux-any],
# --enable-libdrm
 libdrm-dev [linux-any],
# --enable-libfontconfig
 libfontconfig-dev,
# --enable-libfreetype
 libfreetype-dev | libfreetype6-dev,
# --enable-fribidi
 libfribidi-dev,
# --enable-opengl
 libgl1-mesa-dev,
# --enable-libgme
 libgme-dev,
# --enable-gnutls
 libgnutls28-dev | libgnutls-dev,
# --enable-libgsm
 libgsm1-dev,
# Fails to be detected by configure script, if not also libavc1394-dev is installed.
# --enable-libiec61883
 libiec61883-dev [linux-any],
 libavc1394-dev [linux-any],
# --enable-libjack
 libjack-jackd2-dev,
# --enable-liblensfun (used only in -extra flavor)
 liblensfun-dev,
# --enable-lv2
 liblilv-dev,
# autodetected for the tiff decoder
 liblzma-dev,
# --enable-libmfx
 libmfx-dev [amd64],
# --enable-libmp3lame
 libmp3lame-dev,
# --enable-libmysofa
 libmysofa-dev,
# --enable-openal
 libopenal-dev,
# --enable-omx
 libomxil-bellagio-dev,
# --enable-omx-rpi
 libraspberrypi-dev [armhf arm64],
# --enable-libopencore_amrnb
 libopencore-amrnb-dev,
# --enable-libopencore_amrwb
 libopencore-amrwb-dev,
# --enable-libopenjpeg
 libopenjp2-7-dev (>= 2.1),
# --enable-libopenmpt
 libopenmpt-dev,
# --enable-libopus
 libopus-dev,
# --enable-pocketsphinx
 libpocketsphinx-dev (>= 0.8+5prealpha+1-7~) [!alpha !hppa !ia64 !m68k !mipsel !mips64el !powerpc !ppc64 !s390x !sparc64],
# --enable-libpulse
 libpulse-dev,
# --enable-librabbitmq
 librabbitmq-dev,
# --enable-librubberband
 librubberband-dev,
# --enable-librsvg
 librsvg2-dev,
# autodetected: protocol 'sctp'
 libsctp-dev [linux-any],
# --enable-sdl2
 libsdl2-dev,
# --enable-libshine
 libshine-dev (>= 3.0.0),
# --enable-libsnappy
 libsnappy-dev,
# --enable-libsoxr
 libsoxr-dev,
# --enable-libspeex
 libspeex-dev,
# --enable-libsrt
 libsrt-gnutls-dev,
# --enable-libssh
 libssh-gcrypt-dev,
# --enable-libtesseract (used only in -extra flavor)
 libtesseract-dev,
# --enable-libtheora
 libtheora-dev,
# --enable-libtwolame
 libtwolame-dev,
# This is not necessary, see explanation in debian/rules.
# # --enable-libv4l2
# libv4l-dev [!hurd-any],
# autodetected: hwaccels 'h263_vaapi, mpeg2_vaapi, vc1_vaapi, h264_vaapi, mpeg4_vaapi, wmv3_vaapi'
 libva-dev (>= 1.3) [!hurd-any],
# autodetected: hwaccels 'h263_vdpau, mpeg2_vdpau, vc1_vdpau, h264_vdpau, mpeg4_vdpau, wmv3_vdpau, mpeg1_vdpau', decoders 'h264_vdpau, mpeg1_vdpau, mpeg4_vdpau, mpeg_vdpau, vc1_vdpau, wmv3_vdpau'
 libvdpau-dev,
# --enable-libvidstab
 libvidstab-dev,
# --enable-libvo_amrwbenc
 libvo-amrwbenc-dev,
# --enable-libvorbis
 libvorbis-dev,
# --enable-libvpx
 libvpx-dev,
# --enable-libwavpack
 libwavpack-dev,
# --enable-libwebp
 libwebp-dev,
# --enable-libx264
 libx264-dev <!pkg.ffmpeg.stage1>,
# --enable-libx265
 libx265-dev (>= 1.8),
# autodetected libxcb-shape
 libxcb-shape0-dev,
# autodetected libxcb-shm
 libxcb-shm0-dev,
# autodetected libxcb-xfixes
 libxcb-xfixes0-dev,
# --enable-libxml2
 libxml2-dev,
# autodetected xlib
 libxv-dev,
# --enable-libxvid
 libxvidcore-dev,
# autodetected: decoder 'mpeg_xvmc'; outdev 'xv'
 libxvmc-dev,
# --enable-libzmq
 libzmq3-dev,
# --enable-libzvbi
 libzvbi-dev,
# --enable-opencl
 ocl-icd-opencl-dev | opencl-dev,
# used to detect libraries
 pkg-config,
 linux-libc-dev,
# HTML documentation
 texinfo,
# assembler optimizations
 nasm,
 pkg-kde-tools,
# autodetected zlib
 zlib1g-dev,
 libepoxy-dev,
 libxcb-dri3-dev,
 libxcb1-dev,
 libx11-dev,
 libx11-xcb-dev,
 libdrm-dev

Package: ffmpeg
Architecture: any
Multi-Arch: foreign
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Suggests:
 ffmpeg-doc
Breaks: libav-tools (<< 6:12~~),
 qt-faststart (<< 7:2.7.1-3~),
 winff (<< 1.5.5-5~),
Replaces: libav-tools (<< 6:12~~),
 qt-faststart (<< 7:2.7.1-3~)
Description: Tools for transcoding, streaming and playing of multimedia files
 FFmpeg is the leading multimedia framework, able to decode, encode, transcode,
 mux, demux, stream, filter and play pretty much anything that humans and
 machines have created. It supports the most obscure ancient formats up to the
 cutting edge.
 .
 This package contains:
  * ffmpeg: a command line tool to convert multimedia files between formats
  * ffplay: a simple media player based on SDL and the FFmpeg libraries
  * ffprobe: a simple multimedia stream analyzer
  * qt-faststart: a utility to rearrange Quicktime files

Package: ffmpeg-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends:
 libjs-jquery,
 libjs-bootstrap,
 ${misc:Depends}
Description: Documentation of the FFmpeg multimedia framework
 FFmpeg is the leading multimedia framework, able to decode, encode, transcode,
 mux, demux, stream, filter and play pretty much anything that humans and
 machines have created. It supports the most obscure ancient formats up to the
 cutting edge.
 .
 This package contains the HTML documentation for the FFmpeg multimedia
 framework including the API documentation created by doxygen and the manpages
 for the libraries.

Package: libavcodec58
Architecture: any
Section: libs
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends}
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 libraspberrypi0 [armhf arm64]
Description: FFmpeg library with de/encoders for audio/video codecs - runtime files
 FFmpeg is the leading multimedia framework, able to decode, encode, transcode,
 mux, demux, stream, filter and play pretty much anything that humans and
 machines have created. It supports the most obscure ancient formats up to the
 cutting edge.
 .
 This library provides a generic encoding/decoding framework and
 contains multiple decoders and encoders for audio, video and subtitle streams,
 and several bitstream filters.
 .
 The shared architecture provides various services ranging from bit stream I/O
 to DSP optimizations, and makes it suitable for implementing robust and fast
 codecs as well as for experimentation.
 .
 This package contains the runtime files.

Package: libavcodec-extra58
Architecture: any
Section: libs
Multi-Arch: same
Conflicts: libavcodec58
Provides: libavcodec58 (= ${binary:Version})
Pre-Depends:
 ${misc:Pre-Depends}
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 libraspberrypi0 [armhf arm64]
Description: FFmpeg library with additional de/encoders for audio/video codecs
 FFmpeg is the leading multimedia framework, able to decode, encode, transcode,
 mux, demux, stream, filter and play pretty much anything that humans and
 machines have created. It supports the most obscure ancient formats up to the
 cutting edge.
 .
 This library provides a generic encoding/decoding framework and
 contains multiple decoders and encoders for audio, video and subtitle streams,
 and several bitstream filters.
 .
 The shared architecture provides various services ranging from bit stream I/O
 to DSP optimizations, and makes it suitable for implementing robust and fast
 codecs as well as for experimentation.
 .
 This package replaces the libavcodec58 package and contains the
 following additional codecs:
 .
  * ARIB STD-B24 Captions (Subtitle Decoder)
  * OpenCORE Adaptive Multi-Rate (AMR) Narrow-Band (Encoder/Decoder)
  * OpenCORE Adaptive Multi-Rate (AMR) Wide-Band (Decoder)
  * Android VisualOn Adaptive Multi-Rate (AMR) Wide-Band (Encoder)
 .
 Because this package links against libraries that are licensed under
 Apache License 2.0, the resulting binaries are distributed under the
 GPL version 3 or later.

Package: libavcodec-extra
Architecture: any
Section: metapackages
Multi-Arch: same
Depends:
 libavcodec-extra58 (= ${binary:Version}),
 ${misc:Depends}
Description: FFmpeg library with extra codecs (metapackage)
 FFmpeg is the leading multimedia framework, able to decode, encode, transcode,
 mux, demux, stream, filter and play pretty much anything that humans and
 machines have created. It supports the most obscure ancient formats up to the
 cutting edge.
 .
 This metapackage depends on the latest version of the libavcodec variant
 that offers additional codec support. Application packages can depend
 on it if they require or suggest this variant in a robust manner.


Package: libavcodec-dev
Architecture: any
Section: libdevel
Multi-Arch: same
Depends:
 libavcodec58 (= ${binary:Version}),
 libavutil-dev (= ${binary:Version}),
 libswresample-dev (= ${binary:Version}),
 ${misc:Depends}
Description: FFmpeg library with de/encoders for audio/video codecs - development files
 FFmpeg is the leading multimedia framework, able to decode, encode, transcode,
 mux, demux, stream, filter and play pretty much anything that humans and
 machines have created. It supports the most obscure ancient formats up to the
 cutting edge.
 .
 This library provides a generic encoding/decoding framework and
 contains multiple decoders and encoders for audio, video and subtitle streams,
 and several bitstream filters.
 .
 The shared architecture provides various services ranging from bit stream I/O
 to DSP optimizations, and makes it suitable for implementing robust and fast
 codecs as well as for experimentation.
 .
 This package contains the development files.

Package: libavdevice58
Architecture: any
Section: libs
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends}
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 libraspberrypi0 [armhf arm64]
Description: FFmpeg library for handling input and output devices - runtime files
 FFmpeg is the leading multimedia framework, able to decode, encode, transcode,
 mux, demux, stream, filter and play pretty much anything that humans and
 machines have created. It supports the most obscure ancient formats up to the
 cutting edge.
 .
 This library provides a generic framework for grabbing from and rendering to
 many common multimedia input/output devices, and supports several input and
 output devices, including Video4Linux2, VfW, DShow, and ALSA.
 .
 This package contains the runtime files.

Package: libavdevice-dev
Architecture: any
Section: libdevel
Multi-Arch: same
Depends:
 libavcodec-dev (= ${binary:Version}),
 libavdevice58 (= ${binary:Version}),
 libavfilter-dev (= ${binary:Version}),
 libavformat-dev (= ${binary:Version}),
 libavutil-dev (= ${binary:Version}),
 libpostproc-dev (= ${binary:Version}),
 libswscale-dev (= ${binary:Version}),
 libswresample-dev (= ${binary:Version}),
 ${misc:Depends}
Description: FFmpeg library for handling input and output devices - development files
 FFmpeg is the leading multimedia framework, able to decode, encode, transcode,
 mux, demux, stream, filter and play pretty much anything that humans and
 machines have created. It supports the most obscure ancient formats up to the
 cutting edge.
 .

=== debian/rules ===
#!/usr/bin/make -f

export V=1

# sets DEBIAN_VERSION variable
include /usr/share/dpkg/pkg-info.mk

# Get the Debian version revision:
DEB_REVISION := $(word 2, $(subst -, ,$(DEB_VERSION)))

# sets DEB_HOST_* variables
include /usr/share/dpkg/architecture.mk

# Ubuntu ld adds -Bsymbolic-functions by default, but that prevents FFmpeg from building.
export DEB_LDFLAGS_MAINT_STRIP=-Wl,-Bsymbolic-functions

# Package name for the extra flavor.
SHLIB_PKGS := $(shell sed -nr '/extra/! s/^Package:[[:space:]]*(lib.*[0-9]+)[[:space:]]*$$/\1/p' debian/control)
EXTRA_PKGS := $(shell sed -nr 's/^Package:[[:space:]]*(.*extra[0-9]+)[[:space:]]*$$/\1/p' debian/control)
FLAVORS = standard extra static

# Most possible features, compatible with effective licensing of GPLv2+
CONFIG := --prefix=/usr \
	--extra-version="$(DEB_REVISION)" \
	--toolchain=hardened \
	--incdir=/usr/include/$(DEB_HOST_MULTIARCH) \
	--enable-gpl \
	--disable-stripping \
	--enable-avresample --disable-filter=resample \
	--enable-gnutls \
	--enable-ladspa \
	--enable-libaom \
	--enable-libass \
	--enable-libbluray \
	--enable-libbs2b \
	--enable-libcaca \
	--enable-libcdio \
	--enable-libcodec2 \
	--enable-libdav1d \
	--enable-libflite \
	--enable-libfontconfig \
	--enable-libfreetype \
	--enable-libfribidi \
	--enable-libgme \
	--enable-libgsm \
	--enable-libjack \
	--enable-libmp3lame \
	--enable-libmysofa \
	--enable-libopenjpeg \
	--enable-libopenmpt \
	--enable-libopus \
	--enable-libpulse \
	--enable-librabbitmq \
	--enable-librsvg \
	--enable-librubberband \
	--enable-libshine \
	--enable-libsnappy \
	--enable-libsoxr \
	--enable-libspeex \
	--enable-libsrt \
	--enable-libssh \
	--enable-libtheora \
	--enable-libtwolame \
	--enable-libvidstab \
	--enable-libvorbis \
	--enable-libvpx \
	--enable-libwavpack \
	--enable-libwebp \
	--enable-libx265 \
	--enable-libxml2 \
	--enable-libxvid \
	--enable-libzmq \
	--enable-libzvbi \
	--enable-lv2 \
	--enable-omx \
	--enable-openal \
	--enable-opencl \
	--enable-opengl \
	--enable-sdl2

ifeq ($(DEB_HOST_ARCH),armhf)
	FLAVORS += standard_v7 extra_v7 static_v7
	CONFIG += --enable-mmal \
		--enable-neon \
		--enable-rpi \
		--enable-v4l2-request\
		--enable-libudev \
		--enable-epoxy

	CONFIG_v6 = --libdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
		--cpu=arm1176jzf-s \
		--arch=arm
	CONFIG_v7 = --libdir=/usr/lib/$(DEB_HOST_MULTIARCH)/neon/vfp \
		--cpu=cortex-a7 \
		--arch=armv6t2 \
		--disable-thumb
	CONFIG_standard_v7 = $(CONFIG_v7) \
		--enable-shared \
		--disable-doc \
		--disable-programs
	CONFIG_extra_v7 = $(CONFIG_standard_v7) \
		--enable-version3 \
		--disable-doc \
		--disable-programs \
		--enable-liblensfun \
		--enable-libopencore_amrnb \
		--enable-libopencore_amrwb \
		--enable-libtesseract \
		--enable-libvo_amrwbenc
	CONFIG_static_v7 = $(CONFIG_v7) \
		--disable-pic \
		--disable-doc \
		--disable-programs
else ifeq ($(DEB_HOST_ARCH),arm64)
	CONFIG += --disable-mmal \
		--enable-neon \
		--enable-v4l2-request\
		--enable-libudev \
		--enable-epoxy \
		--enable-sand

	CONFIG += --libdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
		--arch=$(DEB_HOST_ARCH_CPU)
else
	CONFIG += --libdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
		--arch=$(DEB_HOST_ARCH_CPU)
endif

# avoid pocketsphinx on mips (bug#812335), alpha, ia64 and big-endian (bug#968456)
ifeq (,$(filter mips% alpha ia64,$(DEB_HOST_ARCH))$(filter big,$(DEB_HOST_ARCH_ENDIAN)))
	CONFIG += --enable-pocketsphinx
endif

ifeq (amd64,$(DEB_HOST_ARCH))
CONFIG += --enable-libmfx
endif

# The standard configuration only uses the shared CONFIG.
CONFIG_standard = --enable-shared \
	$(CONFIG_v6)

# Additional features, compatible with effective licensing of GPLv3+
CONFIG_extra = --enable-shared \
	--enable-version3 \
	--disable-doc \
	--disable-programs \
	--enable-libaribb24 \
	--enable-liblensfun \
	--enable-libopencore_amrnb \
	--enable-libopencore_amrwb \
	--enable-libtesseract \
	--enable-libvo_amrwbenc \
	$(CONFIG_v6)

# The static libraries should not be built with PIC.
CONFIG_static = --disable-pic \
	--disable-doc \
	--disable-programs \
	$(CONFIG_v6)

# Disable optimizations if requested.
ifneq (,$(filter noopt,$(DEB_BUILD_OPTIONS)))
	CONFIG += --disable-optimizations
endif

# Respect CC/CXX from the environment, if they differ from the default.
# Don't set them if they equal the default, because that disables autodetection needed for cross-building.
ifneq (cc,$(CC))
	CONFIG += --cc=$(CC)
endif
ifneq (g++,$(CXX))
	CONFIG += --cxx=$(CXX)
endif

# Some libraries are built only on linux.
ifeq (linux,$(DEB_HOST_ARCH_OS))
	CONFIG += --enable-libdc1394 \
		--enable-libdrm \
		--enable-vout-drm \
		--enable-libiec61883
endif

# ffmpeg is involved in build-dependency cycles with x264 and chromaprint, so disable them in stage one.
# Also disable frei0r, which build-depends on opencv.
ifneq (,$(filter pkg.ffmpeg.stage1,$(DEB_BUILD_PROFILES)))
	CONFIG += --disable-frei0r \
		--disable-chromaprint \
		--disable-libx264
else
	CONFIG += --enable-chromaprint \
		--enable-frei0r \
		--enable-libx264
endif

# Disable altivec optimizations on powerpc, because they are not always available on this architecture.
ifeq (powerpc,$(DEB_HOST_ARCH))
	CONFIG += --disable-altivec
	# Build an altivec flavor of the libraries on powerpc.
	# This works around the problem that runtime cpu detection on powerpc currently does not work,
	# because, if altivec is enabled, all files are build with '-maltivec' so that the compiler inserts altivec instructions, wherever it likes.
	CONFIG_altivec = --enable-shared \
		--enable-altivec \
		--disable-doc \
		--disable-programs
	CONFIG_altivec-extra = $(CONFIG_altivec) $(CONFIG_extra)
	FLAVORS += altivec altivec-extra
endif

# Disable assembly optimizations on x32, because they don't work (yet).
ifneq (,$(filter x32,$(DEB_HOST_ARCH)))
	CONFIG += --disable-asm
endif

# Disable some optimizations on mips*, because they are not always available on these architectures
ifneq (,$(filter mips%r6 mips%r6el, $(DEB_HOST_ARCH)))
	MIPS_R2_R6_CONFIG = --disable-mips32r2 \
		--disable-mips64r2
else
	MIPS_R2_R6_CONFIG = --disable-mips32r6 \
		--disable-mips64r6
endif

ifneq (,$(filter mips%,$(DEB_HOST_ARCH)))
	CONFIG += --disable-mipsdsp \
		--disable-mipsdspr2 \
		--disable-loongson2 \
		--disable-loongson3 \
		--disable-mmi \
		--disable-mips32r5 \
		$(MIPS_R2_R6_CONFIG) \
		--disable-msa \
		--disable-msa2
endif

# Disable mipsfpu on mips and mipsel, because it is not compatible with the FPXX ABI
ifneq (,$(filter mips mipsel,$(DEB_HOST_ARCH)))
	CONFIG += --disable-mipsfpu
endif

# Disable some tests which fail when FLT_EVAL_METHOD != 0 (found on i386, m68k and s390x)
ifneq (,$(filter i386 m68k s390x,$(DEB_HOST_ARCH_CPU)))
	CONFIG += --ignore-tests=hapenc-hap-none,hapenc-hapa-none,hapenc-hapq-none
endif

# Set cross-build prefix for compiler, pkg-config...
ifneq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
	CONFIG += --cross-prefix=$(DEB_HOST_GNU_TYPE)- \
		--target-os=$(DEB_HOST_ARCH_OS)
endif

# Use the default debhelper scripts, where possible.
%:
	dh $@ --with pkgkde_symbolshelper

# Add configuration options:
override_dh_auto_configure: $(patsubst %,configure_%,$(FLAVORS))
configure_%:
	$(info $()   debian/rules $@)
	mkdir -p debian/$*
	cd debian/$* && ../../configure $(strip $(CONFIG) $(CONFIG_$*)) || (cat ffbuild/config.log && exit 1)

# Remove the subdirectories generated for the flavors.
override_dh_auto_clean:
	rm -rf $(patsubst %,debian/%,$(FLAVORS))

# Create doxygen documentation:
override_dh_auto_build-indep:
	dh_auto_build -i --sourcedirectory=debian/standard -- apidoc documentation
	# Create the minified CSS files.
	#  Due to https://github.com/nodejs/node/issues/14752 where nodejs will
	#  leave set O_NONBLOCK on stderr, we pipe stderr through cat which will
	#  create a temporary pipe so this doesn't break the rest of the build.
	#  See: #895154
	(lessc debian/missing-sources/ffmpeg-web/src/less/style.less | cleancss > debian/standard/doc/style.min.css) 2>&1 | cat >&2
